SystemOrganization addCategory: #'Raphael-Examples'!

WAComponent subclass: #RAAllExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Raphael-Examples'!

!RAAllExamples class methodsFor: 'configure' stamp: 'obi 10/10/2009 10:19'!
canBeRoot
	^true! !

!RAAllExamples class methodsFor: 'configure' stamp: 'obi 10/10/2009 10:20'!
description
	^ 'Raphael test application'! !

!RAAllExamples class methodsFor: 'configure' stamp: 'obi 10/10/2009 10:19'!
entryPointName
	^'RaphaelTest'! !

!RAAllExamples class methodsFor: 'configure' stamp: 'obi 1/9/2010 19:03'!
initialize
	(WAAdmin register: self asApplicationAt: self entryPointName)
		addLibrary: PTDeploymentLibrary;
		addLibrary: RALibrary;
		addLibrary: RAGraphLibrary! !

!RAAllExamples methodsFor: 'rendering' stamp: 'obi 1/9/2010 19:43'!
renderContentOn: html
	html heading with: [html html: 'Rapha&euml;l examples'].
	RAExample subclasses do: [:each |
		html anchor
			callback: [self show: each new];
			with: each.
		html break]! !

WAComponent subclass: #RAExample
	instanceVariableNames: 'page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Raphael-Examples'!

RAExample subclass: #RAAnimationExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Raphael-Examples'!

!RAAnimationExample methodsFor: 'accessing' stamp: 'obi 4/2/2010 15:21'!
addShapes
	| shapes animations |
	shapes := self shapes.
	animations := self animations.
	shapes withIndexDo: [:fig :idx | | ani |
			ani := animations at: idx.
			self addFigure: fig.
			ani figure: fig.
			fig onClickHandler add: ani; asFunction]
		! !

!RAAnimationExample methodsFor: 'shapes' stamp: 'obi 9/20/2009 09:35'!
animations
	| animations |
	animations := OrderedCollection new.
	animations add: (RAAnimate new fill: 'red'; opacity: 0.2 ; scale: 0.5; duration: 500 ; yourself).
	animations add: (RAAnimate new fill: 'yellow'; strokeWidth: 4;duration: 500 ; yourself).

	animations add: (RAAnimate new fill: 'yellow'; x: 600 ; rotation: 180; duration: 1000 ; yourself).
	animations add: (RAAnimate new fill: 'yellow'; x: 600 ; speed; rotation: 180;  duration: 1000 ; yourself).
	animations add: (RAAnimate new fill: 'yellow'; x: 600 ; speedUp;rotation: 180;  duration: 1000 ; yourself).
	animations add: (RAAnimate new fill: 'yellow'; x: 600 ; speedDown;rotation: 180;  duration: 1000 ; yourself).
	animations add: (RAAnimate new fill: 'yellow'; x: 600 ; elastic; rotation: 180; duration: 2500 ; yourself).
	animations add: (RAAnimate new fill: 'yellow'; x: 600 ; backIn;rotation: 180;  duration: 1000 ; yourself).
	animations add: (RAAnimate new fill: 'yellow'; x: 600 ; backOut;rotation: 180;  duration: 1000 ; yourself).
	animations add: (RAAnimate new fill: 'yellow'; x: 600 ; bounce;rotation: 180; scale: 0.5;  duration: 1000 ; yourself).
	^animations
! !

!RAAnimationExample methodsFor: 'rendering' stamp: 'obi 9/19/2009 22:09'!
renderHeaderOn: html
	html anchor callback: []; with: 'Reset'! !

!RAAnimationExample methodsFor: 'shapes' stamp: 'obi 8/3/2010 18:00'!
shapes
	| shapes |
	shapes := OrderedCollection new.
	shapes add: (RACircle new x: 100; y:80; radius:50; fill: 'red'; yourself).
	shapes add: (RARectangle new x: 50; y:150; width:100; radius:5; height:50; fill: '#369';yourself).
	
	shapes add: (RARectangle new x: 50; y:230; width:50; radius:10; height:50; opacity: 0.5; fill: '#369';yourself).
	shapes add: (RARectangle new x: 50; y:300; width:50; radius:10; height:50; opacity: 0.5; fill: '#369';yourself).
	shapes add: (RARectangle new x: 50; y:370; width:50; radius:10; height:50; opacity: 0.5; fill: '#369';yourself).
	shapes add: (RARectangle new x: 50; y:440; width:50; radius:10; height:50; opacity: 0.5; fill: '#369';yourself).
	shapes add: (RARectangle new x: 50; y:510; width:50; radius:10; height:50; opacity: 0.5; fill: '#369';yourself).
	shapes add: (RARectangle new x: 50; y:580; width:50; radius:10; height:50; opacity: 0.5; fill: '#369';yourself).
	shapes add: (RARectangle new x: 50; y:650; width:50; radius:10; height:50; opacity: 0.5; fill: '#369';yourself).
	shapes add: (RARectangle new x: 50; y:720; width:50; radius:10; height:50; opacity: 0.5; fill: '#369';yourself).
	^shapes! !

!RAAnimationExample methodsFor: 'accessing' stamp: 'obi 9/19/2009 21:51'!
title
	^'Raphael Animation Tests'! !

!RAExample methodsFor: 'convenience' stamp: 'obi 10/10/2009 10:07'!
addFigure: aFigure
	page isNil ifFalse: [ page addFigure: aFigure ]! !

!RAExample methodsFor: 'accessing' stamp: 'obi 6/3/2010 17:42'!
extent
	^1100@900! !

!RAExample methodsFor: 'initialize-release' stamp: 'obi 4/3/2010 10:56'!
initialize
	super initialize.
	self raphaelView! !

!RAExample methodsFor: 'accessing' stamp: 'obi 6/3/2010 17:43'!
raphaelView
	page isNil
		ifTrue: [
		page := Raphael new
			id: 'myView';
			extent: self extent;
			yourself.
		self addShapes ].
	^page
		! !

!RAExample methodsFor: 'rendering' stamp: 'obi 4/2/2010 13:38'!
renderContentOn: html

	html heading
		level: 3;
		with: self title.
	self renderHeaderOn: html.
	self renderViewOn: html.
	self renderInfoBarOn: html! !

!RAExample methodsFor: 'rendering' stamp: 'obi 9/19/2009 21:38'!
renderHeaderOn: html
! !

!RAExample methodsFor: 'rendering' stamp: 'obi 6/4/2010 10:11'!
renderInfoBarOn: html
	html div
		id: 'infoBar';
		style: 'clear:both;width:1100px;height:20px;background:#888;border:1px solid #444;color:#fff';
		with: 'Selected:'! !

!RAExample methodsFor: 'rendering' stamp: 'obi 6/4/2010 10:10'!
renderViewOn: html
	html render: self raphaelView.
	html div id: 'myView'; style: 'position:relative;height:820px;width:1120px;border:1px solid #888;overflow:auto;float:left'! !

!RAExample methodsFor: 'accessing' stamp: 'obi 9/19/2009 21:40'!
title
	^''! !

!RAExample methodsFor: 'rendering' stamp: 'obi 7/18/2010 17:56'!
updateInfoBarOn: script with: label
	script prototype element id: 'infoBar';
		update: [:r | r render: label ]! !

RAExample subclass: #RAMainExample
	instanceVariableNames: 'random selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Raphael-Examples'!

!RAMainExample methodsFor: 'actions' stamp: 'obi 7/12/2010 19:50'!
addCircle
	| newObject handler |
	newObject := RACircle new
						x: (self random nextInt: 900) + 30;
						y:(random nextInt: 700) + 30;
						radius: 30;
						fill: 'red';
						strokeWidth: 1;
						opacity: ((random nextInt: 10) / 10) asFloat;
						yourself.

	page addFigure: newObject.
	self addDraggableTo: newObject.
	^newObject! !

!RAMainExample methodsFor: 'rendering' stamp: 'obi 7/18/2010 18:17'!
addColorOn: script
	selection isNil
		ifFalse: [
			selection fill: Color random asHTMLColor.
			script add: (selection attributesAsJSStream)]! !

!RAMainExample methodsFor: 'rendering' stamp: 'obi 7/18/2010 18:35'!
addColorsToAllOn: script
	page figures do: [:fig |
		fig fill: Color random asHTMLColor.
		fig stroke: Color random asHTMLColor.
		script add: (fig attributesAsJSStream) ]
	! !

!RAMainExample methodsFor: 'actions' stamp: 'obi 10/8/2010 22:18'!
addComposite
	| rect handler composite newObject newObject2 |
	composite := RACompositeFigure new parent: page; yourself .
	rect := RARectangle new 
							x: 10;
							y: 10; 
							width:120;
							height: 100;
							fill: '90-#369-#69c:60-#9cf';
							radius: 8;
							strokeWidth: 1;
							opacity: 1; yourself.
	newObject := RACircle new
					x: 100;
					y: 20;
					radius: 8;
					fill: 'red';
					strokeWidth: 1;
					opacity: 0.8;
					yourself.
		newObject2 := RACircle new
					x: 100;
					y: 40;
					radius: 8;
					fill: 'green';
					strokeWidth: 1;
					opacity: 0.8;
					yourself.
				
	composite root: rect; add: newObject; add: newObject2.
	page addFigure: composite.
	self addDraggableTo: rect.
	^composite! !

!RAMainExample methodsFor: 'private' stamp: 'obi 7/12/2010 20:26'!
addDraggableTo: anObject
	anObject addDrag
	"onMousedownHandler script: 'dragger'."! !

!RAMainExample methodsFor: 'actions' stamp: 'obi 7/12/2010 19:50'!
addEllipse
	| newObject handler |
	newObject := RAEllipse new
						x: (self random nextInt: 900) + 30;
						y:(random nextInt: 700) + 30;
						radiusX: 35;
						radiusY: 25;
						fill: 'orange';
						strokeWidth: 1;
						opacity: ((random nextInt: 10) / 10) asFloat;
						yourself.
	page addFigure: newObject.
	self addDraggableTo: newObject.
	^newObject! !

!RAMainExample methodsFor: 'actions' stamp: 'obi 7/12/2010 19:50'!
addImage
	| newObject factor| 
	factor := ((self random nextInt: 8) / 10) asFloat + 0.2. 
	newObject := RAImage new
						x: (self random nextInt: 900) + 10;
						y:(random nextInt: 700) + 10;
						src: self imageTestUrl;
						width: 264;
						height: 142;
						opacity: ((random nextInt: 10) / 10) asFloat;
						yourself.
"	newObject addAction: [:fig |fig scale: (Point x: factor y: factor)]."

	page addFigure: newObject.
	self addDraggableTo: newObject.
	^newObject! !

!RAMainExample methodsFor: 'actions' stamp: 'obi 7/12/2010 19:50'!
addLine
	| newObject |
	newObject := RALine new
						x: (self random nextInt: 900) + 10;
						y:(random nextInt: 700) + 10;
						xTo: (self random nextInt: 900) + 10;
						yTo:(random nextInt: 700) + 10;
						strokeWidth: 2;
						strokeDash: '--.';
						yourself.

	page addFigure: newObject.
	self addDraggableTo: newObject.
	^newObject! !

!RAMainExample methodsFor: 'actions' stamp: 'obi 7/12/2010 19:51'!
addPolygone
	| newObject offset angle |
	offset := Point x: (self random nextInt: 900) + 10 y:(random nextInt: 700) + 10.
	angle := self random nextInt: 359.
	newObject := RAPolygone new
						points: (Array with: (10@10 + offset) with: (30@30 + offset) with: (10@50 + offset));
						fill: 'green';
						yourself.
	newObject addAction: [:fig | fig rotate: angle].

	page addFigure: newObject.
	self addDraggableTo: newObject.
	^newObject! !

!RAMainExample methodsFor: 'actions' stamp: 'obi 7/12/2010 19:50'!
addPolyline
	| newObject offset angle |
	offset := Point x: (self random nextInt: 900) + 10 y:(random nextInt: 700) + 10.
	angle := self random nextInt: 359.
	newObject := RAPolyline new points: (Array with: (10@10 + offset) with: (20@20 + offset) with: (10@30 + offset)); yourself.
	newObject addAction: [:fig | fig rotate: angle].

	page addFigure: newObject.
	self addDraggableTo: newObject.
	^newObject! !

!RAMainExample methodsFor: 'actions' stamp: 'obi 10/8/2010 21:20'!
addRectangle
	| rect handler |
	rect := RARectangle new 
							x: (self random nextInt: 950) + 10;
							y:(random nextInt: 800) + 10; 
							width:120;
							height: 100;
							fill: '90-#369-#69c:60-#9cf';
							radius: 8;
							strokeWidth: 1;
							opacity: ((random nextInt: 10) / 10) asFloat; yourself.

	page addFigure: rect.
	self addDraggableTo: rect.
	^rect! !

!RAMainExample methodsFor: 'accessing' stamp: 'obi 8/3/2010 17:59'!
addShapes
	| circle animation |
	self setOnClickFor: page.
	self addFigure: (circle := RACircle new x: 100; y:50; radius:60; yourself).
	animation := (RAAnimate on: circle) addAttributeValues: (Array with: 'fill'->'red' with: 'opacity'->0.2 with: 'scale'-> 0.5 );duration: 500 ; yourself.
	circle
		fill: 'green';
		opacity: 0.5;
		stroke: 'blue';
		addEvent: ((RAOnClickHandler on: circle) add: animation; asFunction; yourself).
	self addFigure: (RACircle new x: 200; y:150; radius:50; fill: 'yellow';yourself).
	self addFigure: (RAEllipse new x: 200; y:350; radiusX:150; radiusY: 100; fill: '#ccc';yourself).
	self addFigure: (RARectangle new x: 400; y:250; width:150; radius:5; height:50; fill: '#69f';yourself)! !

!RAMainExample methodsFor: 'actions' stamp: 'obi 4/2/2010 16:20'!
addText
	| newObject |
	newObject := RAText new
						x: (self random nextInt: 900) + 50;
						y: (random nextInt: 700) + 50;
						text: 'Raphael rules';
						fontSize: 16;
						font: 'verdana';
						opacity: ((random nextInt: 10) / 10) asFloat; yourself.
	self addDraggableTo: newObject.
	page addFigure: newObject.
	^newObject! !

!RAMainExample methodsFor: 'private' stamp: 'obi 9/17/2009 20:06'!
imageTestUrl
	^'http://www.seaside.st/styles/logo-plain.png'! !

!RAMainExample methodsFor: 'accessing' stamp: 'obi 04/06/2010 08:08'!
random
	random isNil ifTrue: [random := Random seed: (Time now asSeconds)].
	^random! !

!RAMainExample methodsFor: 'rendering' stamp: 'obi 6/3/2010 14:20'!
renderActionsOn: html
	html anchor url: '#'; onClick: (html prototype request callback: [:value |  page saveJSString: value ] value:  (JSStream on: page variable, '.save()')); with: 'Save'.
	html space.
	html anchor callback: [ self setOnClickFor: page]; with: 'Select'.
	html space.
	html anchor callback: [page setOnClickDelete]; with: 'Delete'.

! !

!RAMainExample methodsFor: 'rendering' stamp: 'obi 10/8/2010 22:20'!
renderAjaxActionsOn: html
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | script add: (self addCircle) ]); with: 'Circle'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | script add: (self addEllipse) ]); with: 'Ellipse'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | script add: (self addRectangle) ]); with: 'Rectangle'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | script add: (self addText) ]); with: 'Text'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | script add: (self addLine) ]); with: 'Line'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | script add: (self addPolyline) ]); with: 'Polyline'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | script add: (self addComposite) ]); with: 'Composite'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | script add: (self addImage) ]); with: 'Image'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | 100 timesRepeat: [script add: (self addLine) ]]); with: '100 Lines'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | 100 timesRepeat: [script add: (self addRectangle) ]]); with: '100 Rectangles'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | 100 timesRepeat: [script add: (self addCircle) ]]); with: '100 Circles'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | script add: (page jsRemoveAll) ]); with: 'Remove All'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | 
			script add: (page jsZoomIn). 
			script prototype element id: 'zoom'; update: [:r | r text: page zoomInPercent ]  ]); with: '+'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | 
			script add: (page jsZoomOut).
			script prototype element id: 'zoom'; update: [:r | r text: page zoomInPercent ] ]); with: '-'.
	html space.
	html span id: 'zoom'; with: '100%'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | 
		script add: (page jsSetZoom: 1).
		script prototype element id: 'zoom'; update: [:r | r text: page zoomInPercent ] ]); with: 'Reset'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | self addColorOn: script ]); with: 'Colorize'.
	html space.
	html anchor url: '#'; onClick: (html prototype evaluator callback: [:script | self addColorsToAllOn: script ]); with: 'Colorize all'.
		
! !

!RAMainExample methodsFor: 'rendering' stamp: 'obi 7/18/2010 17:58'!
renderHeaderOn: html
	self renderActionsOn: html.
	html break.
	self renderAjaxActionsOn: html.
	html break
! !

!RAMainExample methodsFor: 'actions' stamp: 'obi 7/18/2010 18:02'!
setOnClickFor: aPage
	aPage onClickBlock: [:script :figure |
		self updateInfoBarOn: script with: figure printString. 
		selection := figure].! !

!RAMainExample methodsFor: 'accessing' stamp: 'obi 9/12/2009 20:56'!
title
	^'Raphael Test'! !
RAAllExamples initialize!
